#!/bin/bash

BINPAYH=/opt/apps/com.gdca.gdcaclient/files/bin
LIBPATH=/opt/apps/com.gdca.gdcaclient/files/lib

#添加环境变量
export PATH="$BINPAYH:$PATH"
export LD_LIBRARY_PATH="$LIBPATH:$LD_LIBRARY_PATH"
#export QT_PLUGIN_PATH="/opt/GdcaClient/plugins/:$QT_PLUGIN_PATH"

ARCH=`arch`
if [ "$ARCH" = "mips64" ];then
	ARCH="mips64el"
fi

#如果系统不存在libnss3,添加libnss3库环境变量
LIBNSS3=`dpkg -l | grep libnss3`
ARCH_LINUX_GNU=${ARCH}"-linux-gnu*"
if [ -f /usr/lib/$ARCH_LINUX_GNU*/libnss3.so ]; then

    LIBNSS3_VERSION=`strings /usr/lib/$ARCH_LINUX_GNU/libnss3.so | grep NSS_3.39`
    if [ "$LIBNSS3_VERSION" = "" ];then
        echo export libnss3 
	    export LD_LIBRARY_PATH="$LIBPATH/$ARCH_LINUX_GNU:$LD_LIBRARY_PATH"	
    fi

else
    echo export libnss3
    export LD_LIBRARY_PATH="$LIBPATH/$ARCH_LINUX_GNU:$LD_LIBRARY_PATH"
   
fi


#启动服务
ClientService=`pgrep gdca_daemon`
if [ "$ClientService" = "" ];then
    if [ -f /opt/apps/com.gdca.gdcaclient/files/bin/gdca_daemon ]; then
       /opt/apps/com.gdca.gdcaclient/files/bin/gdca_daemon 
    fi
fi

#source /etc/profile
#qi dong ke hu duan
#pgrep GdcaCertManager
#if [ $? -ne 0 ]; then
#    if [ -f /opt/apps/com.gdca.gdcaclient/files/bin/GdcaCertManager ]; then
#        /opt/apps/com.gdca.gdcaclient/files/bin/GdcaCertManager &
#    fi
#fi
