#! /bin/bash

FILES=/opt/apps/com.gdca.gdcaclient/files
BINPAYH=/opt/apps/com.gdca.gdcaclient/files/bin
LIBPATH=/opt/apps/com.gdca.gdcaclient/files/lib

#添加环境变量
ARCH=`arch`
if [ "$ARCH" = "mips64" ];then
	ARCH="mips64el"
fi
ARCH_LINUX_GNU=${ARCH}"-linux-gnu*"

export PATH="$BINPAYH:$PATH"
export LD_LIBRARY_PATH="$LIBPATH:$LIBPATH/$ARCH_LINUX_GNU:$LD_LIBRARY_PATH"

for j in /home/*/.mozilla; do

	for k in $j/firefox*; do

	if [ -f $k/profiles.ini ];then

    	FILENUM=`cat $k/profiles.ini | grep "^Path=" | awk -F= '{print $2}' | wc -l`  	

    	for ((i=1;i<=$FILENUM;i++));
    	do
	   		FILENAME=`cat $k/profiles.ini | grep "^Path=" | awk -F= '{print $2}' | head -n $i | tail -n 1`
       		FILEPATH=$k/$FILENAME
       		CertUtil=`certutil -d sql:$FILEPATH -L | grep "Certificate Client Service"`
       	if [[ -d $FILEPATH  && -z "$CertUtil" ]];then
       		certutil -A -n "Certificate Client Service Root 0" -t "C,C,C" -i $FILES/certs/Certificate_Client_Service_Root_0.crt -d dbm:$FILEPATH
			certutil -A -n "Certificate Client Service CA 0"   -t "C,C,C" -i $FILES/certs/Certificate_Client_Service_CA_0.crt   -d dbm:$FILEPATH
			certutil -A -n "Certificate Client Service Root 0" -t "C,C,C" -i $FILES/certs/Certificate_Client_Service_Root_0.crt -d sql:$FILEPATH
			certutil -A -n "Certificate Client Service CA 0"   -t "C,C,C" -i $FILES/certs/Certificate_Client_Service_CA_0.crt   -d sql:$FILEPATH
    	fi

    	done
    	unset i
	fi

	done
	unset k

done
unset j


#360浏览和系统浏览器安装证书
for i in /home/*/.pki/nssdb/;do
    if [ -d $i ];then         
        certutil -A -n "Certificate Client Service Root 0" -t "C,C,C" -i $FILES/certs/Certificate_Client_Service_Root_0.crt -d dbm:$i
        certutil -A -n "Certificate Client Service CA 0"   -t "C,C,C" -i $FILES/certs/Certificate_Client_Service_CA_0.crt   -d dbm:$i
        certutil -A -n "Certificate Client Service Root 0" -t "C,C,C" -i $FILES/certs/Certificate_Client_Service_Root_0.crt -d sql:$i
        certutil -A -n "Certificate Client Service CA 0"   -t "C,C,C" -i $FILES/certs/Certificate_Client_Service_CA_0.crt   -d sql:$i  
    fi
done
unset i

#奇安信浏览器安装证书
for i in /home/*/.pki/nssdb/.config/qaxbrowser/;do
	CertUtil=`certutil -d sql:$i -L | grep "Certificate Client Service"`
    if [[ -d $i && -z "$CertUtil" ]];then         
        certutil -A -n "Certificate Client Service Root 0" -t "C,C,C" -i $FILES/certs/Certificate_Client_Service_Root_0.crt -d dbm:$i
        certutil -A -n "Certificate Client Service CA 0"   -t "C,C,C" -i $FILES/certs/Certificate_Client_Service_CA_0.crt   -d dbm:$i
        certutil -A -n "Certificate Client Service Root 0" -t "C,C,C" -i $FILES/certs/Certificate_Client_Service_Root_0.crt -d sql:$i
        certutil -A -n "Certificate Client Service CA 0"   -t "C,C,C" -i $FILES/certs/Certificate_Client_Service_CA_0.crt   -d sql:$i
    fi
done
unset i
